package main

import (
	"bytes"
	"log"
	"net"
	"net/url"
	"os/exec"
	"strings"
)

func serveCommand(c net.Conn, serve *pathConfig, request *url.URL, command []string) {
	var args []string
	if len(command) > 0 {
		args = command[1:]
	}
	cmd := exec.Command(command[0], args...)

	var buf bytes.Buffer
	if request.RawQuery != "" {
		requestQuery, err := url.QueryUnescape(request.RawQuery)
		if err != nil {
			writeStatus(c, statusBadRequest)
			return
		}
		cmd.Stdin = strings.NewReader(requestQuery + "\n")
	}
	cmd.Stdout = &buf
	cmd.Stderr = &buf

	err := cmd.Run()
	if err != nil {
		writeStatus(c, statusProxyError)
		return
	}

	writeSuccess(c, serve, geminiType, int64(buf.Len()))
	c.Write(buf.Bytes())

	if verbose {
		log.Printf("< %s\n", command)
	}
}
